﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Steema.TeeChart;
using Steema.TeeChart.Styles;
using Steema.TeeChart.Tools;

namespace OffsetProb
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
      InitializeChart();

      DrawTrend();
    }

    public void InitializeChart()
    {
      ChartControl.Axes.Right.Visible = true;
      ChartControl.Axes.Right.Labels.Visible = false;
      ChartControl.Axes.Top.Visible = true;
      ChartControl.Axes.Top.Labels.Visible = false;

      //Set the basic chart properties
      ChartControl.Axes.Bottom.Labels.Visible = false;


      ChartControl.Axes.Bottom.Labels.Font.Brush.Color = Color.Transparent;
      ChartControl.Axes.Bottom.Ticks.Visible = false;
      ChartControl.Axes.Bottom.TicksInner.Visible = true;
      ChartControl.Axes.Bottom.MinorTicks.Visible = false;
      ChartControl.Axes.Bottom.Grid.Visible = false;

      ChartControl.Axes.Bottom.Automatic = true;

      ChartControl.Panel.MarginLeft = 0;
      ChartControl.Panel.MarginRight = 0;
      ChartControl.Panel.MarginTop = 0;
      ChartControl.Panel.MarginBottom = 0;

      ChartControl.Header.Visible = false;
      ChartControl.Aspect.View3D = false;
      ChartControl.Legend.Visible = false;

    }

    public void DrawTrend()
    {
      FastLine _FastLIne = new FastLine();
      _FastLIne.FillSampleValues(1000);
      
      Axis _Axis = new Axis(ChartControl.Chart);
      ChartControl.Axes.Custom.Add(_Axis);
      _Axis.StartEndPositionUnits = PositionUnits.Percent;
      _Axis.StartPosition = 0;
      _Axis.EndPosition = 100;
      //_Axis.MaximumOffset = 25;
      //_Axis.MinimumOffset = 25;
      _FastLIne.CustomVertAxis = _Axis;
      ChartControl.Series.Add(_FastLIne);
      ChartControl.Draw();
 
      ColorBand _ColorBand = new ColorBand(ChartControl.Chart);
      _ColorBand.Axis = _Axis;
      _ColorBand.Color = Color.Yellow;
      _ColorBand.Transparency = 75;
      _ColorBand.Brush.Color = Color.Yellow;
      _ColorBand.Start = _Axis.Minimum;
      _ColorBand.End = _Axis.Maximum;

      //Draw rect tool

      int RectTop = _Axis.IStartPos;
      //Calculate the Height
      int RectHeight = _Axis.IAxisSize;

      //Calculate the left
      Random rand = new Random();

      int RectLeft = ChartControl.Axes.Bottom.CalcPosValue(_FastLIne.XValues[200]);
      //Calculate the Width 
      int RectWidth = ChartControl.Axes.Bottom.CalcPosValue(_FastLIne.XValues[400]) - RectLeft;

      //check if the rectangle with the same width is already there.
      //if there pick it an update in new list.

      //if not there create a new one.
      RectangleTool _RectTool = GetRectTool(ChartControl, RectLeft, RectTop, RectWidth, RectHeight);
      //_RectTool.Shape.Color = Color.LightGray;
      _RectTool.Shape.Brush.Style = System.Drawing.Drawing2D.HatchStyle.DarkVertical;
      _RectTool.Shape.Pen.Color = Color.LightGray;

      ChartControl.Tools.Add(_ColorBand);
      ChartControl.Tools.Add(_RectTool);

    }

    public RectangleTool GetRectTool(TChart CahrtControl, int Left, int Top, int Width, int Height)
    {
      RectangleTool _RectTool = new RectangleTool(CahrtControl.Chart);
      _RectTool.Left = Left;
      _RectTool.Top = Top;
      _RectTool.Width = Width;
      _RectTool.Height = Height;
      _RectTool.AllowDrag = false;
      _RectTool.AllowEdit = false;
      _RectTool.AllowResize = false;
      _RectTool.AutoSize = false;
      //TODO: 
      //Color and Style can be modified here

      return _RectTool;
    }

    private void ChartControl_Zoomed(object sender, EventArgs e)
    {
      UpdateRect();
    }

    private void ChartControl_UndoneZoom(object sender, EventArgs e)
    {
      UpdateRect();
    }
    private void UpdateRect()
    {
      ChartControl.Tools.RemoveAt(1);

      ChartControl.Refresh();
      //Draw rect tool
      int RectTop = ChartControl.Axes.Custom[0].IStartPos;
      //Calculate the Height
      int RectHeight = ChartControl.Axes.Custom[0].IAxisSize;

      //Calculate the left
      int RectLeft = ChartControl.Axes.Bottom.CalcPosValue(ChartControl.Series[0].XValues[200]);
      //Calculate the Width 
      int RectWidth = ChartControl.Axes.Bottom.CalcPosValue(ChartControl.Series[0].XValues[400]) - RectLeft;

      //check if the rectangle with the same width is already there.
      //if there pick it an update in new list.

      //if not there create a new one.
      RectangleTool _RectTool = GetRectTool(ChartControl, RectLeft, RectTop, RectWidth, RectHeight);
      //_RectTool.Shape.Color = Color.LightGray;
      _RectTool.Shape.Brush.Style = System.Drawing.Drawing2D.HatchStyle.DarkVertical;
      _RectTool.Shape.Pen.Color = Color.LightGray;
      ChartControl.Tools.Add(_RectTool);
    }
  }
}
